//
//  This file is part of SienaXML, an XML interface to the 
//  Siena wide-area event notification system.
//  See http://www.cs.colorado.edu/serl/siena/
//
//  Author: Chris Corliss <corliss@falcon.stortek.com>
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 2001-2002 University of Colorado
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
//
// $Id: NotificationBuilderDialog.java,v 1.1.1.1 2002/06/10 20:53:31 jgiacomo Exp $
//
/*
 * NotificationBuilderDialog.java
 *
 * Created on November 27, 2001, 11:03 AM
 */

package siena.xml.demo;

/**
 *
 * @author  CorliC
 */
public class NotificationBuilderDialog extends javax.swing.JDialog {

    String xmlNotification = null;
    
    /** Creates new form NotificationBuilderDialog */
    public NotificationBuilderDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jScrollPane1 = new javax.swing.JScrollPane();
        xmlEditor = new javax.swing.JTextArea();
        clearButton = new javax.swing.JButton();
        loadButton = new javax.swing.JButton();
        closeButton = new javax.swing.JButton();
        
        getContentPane().setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        setTitle("XML Notification Builder");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });
        
        xmlEditor.setToolTipText("Enter a XML notification here");
        xmlEditor.setTabSize(4);
        jScrollPane1.setViewportView(xmlEditor);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.gridheight = 4;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.ipadx = 257;
        gridBagConstraints1.ipady = 230;
        gridBagConstraints1.insets = new java.awt.Insets(10, 10, 0, 0);
        getContentPane().add(jScrollPane1, gridBagConstraints1);
        
        clearButton.setToolTipText("clear the notification");
        clearButton.setText("Clear Notification");
        clearButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearButtonActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.gridwidth = 3;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(10, 10, 0, 0);
        getContentPane().add(clearButton, gridBagConstraints1);
        
        loadButton.setToolTipText("Load notification from a file");
        loadButton.setText("Load Notification");
        loadButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadButtonActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(13, 10, 0, 0);
        getContentPane().add(loadButton, gridBagConstraints1);
        
        closeButton.setToolTipText("This will close the window and save the notification");
        closeButton.setText("close dialog");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(153, 10, 0, 0);
        getContentPane().add(closeButton, gridBagConstraints1);
        
        pack();
    }//GEN-END:initComponents

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // Add your handling code here:
        this.setVisible(false);
    }//GEN-LAST:event_closeButtonActionPerformed

    private void loadButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadButtonActionPerformed
        // Add your handling code here:
        javax.swing.JFileChooser fileChooser = new javax.swing.JFileChooser();
        if (lastDir != null) {
            fileChooser.setCurrentDirectory(lastDir);
        }
        int returnValue = fileChooser.showOpenDialog(this);
        if (returnValue == javax.swing.JFileChooser.APPROVE_OPTION) {
            xmlEditor.setText("");
            java.io.File selectedFile = fileChooser.getSelectedFile();
            try {
            java.io.BufferedReader reader = new java.io.BufferedReader(new java.io.FileReader(selectedFile));
            String text = reader.readLine();
            while (text != null) {
                xmlEditor.append(text+"\n");
                text = reader.readLine();
            }
            } catch (java.io.IOException exception) {
                javax.swing.JOptionPane.showMessageDialog(this, exception.getMessage());
                return;
            }
        } else {
            return;
        }        
    }//GEN-LAST:event_loadButtonActionPerformed

    private void clearButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearButtonActionPerformed
        // Add your handling code here:
        int confirm = javax.swing.JOptionPane.showConfirmDialog(this, "Are you sure?");
        if (confirm == javax.swing.JOptionPane.YES_OPTION) {
            xmlEditor.setText("");
        }
    }//GEN-LAST:event_clearButtonActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog

    public void setDirectory(java.io.File dir) {
        lastDir = dir;
    }
    
    String getNotification() {
        return xmlEditor.getText();
    }    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea xmlEditor;
    private javax.swing.JButton clearButton;
    private javax.swing.JButton loadButton;
    private javax.swing.JButton closeButton;
    // End of variables declaration//GEN-END:variables

    private java.io.File lastDir = null;
}
