//
//  This file is part of SienaXML, an XML interface to the 
//  Siena wide-area event notification system.
//  See http://www.cs.colorado.edu/serl/siena/
//
//  Author: Chris Corliss <corliss@falcon.stortek.com>
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 2001-2002 University of Colorado
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
//
// $Id: ExistsCondition.java,v 1.1.1.1 2002/06/07 22:42:37 jgiacomo Exp $
//
/* Generated by Together */

package siena.xml.rules;

/** Condition that checks to see if something exists (not null) or not (null)
 */
public class ExistsCondition implements Condition {

    /** Flag that indicates if the check is to see if the object exists or not.
     */    
    private boolean shouldItExist;

    /**
     * This is the consturctor for this condition object.
     *
     * @param shouldItExist Boolean that sets whether the object to be tested
     *  					should exist or not.
     */

    public ExistsCondition(boolean shouldItExist) {
        this.shouldItExist = shouldItExist;
    }

    /**
     * This method tests to see if the object should or should not be present in
     * the tag. If the object should be present in the tag and it is not, then
     * this method will return false. If the object should not be present in the
     * tag and it is, then this method will also return false. All other cases
     * the method will return true.
     *
     * @param whatToEvaluate Object to see if it should be present or not in the
     * tag.
     * @return true or false.
     */

    public boolean meetCondition(Object whatToEvaluate) {
		if (whatToEvaluate != null && shouldItExist) {
	        return true;
        } else if (whatToEvaluate == null && !shouldItExist) {
            return true;
        }

        return false;
    }

}
