//
//  This file is part of SienaXML, an XML interface to the 
//  Siena wide-area event notification system.
//  See http://www.cs.colorado.edu/serl/siena/
//
//  Author: Chris Corliss <corliss@falcon.stortek.com>
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 2001-2002 University of Colorado
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
//
// $Id: CompoundPredicateTest.java,v 1.1.1.1 2002/06/07 22:42:37 jgiacomo Exp $
//

/*
 * CompoundPredicateTest.java
 * JUnit based test
 *
 * Created on December 2, 2001, 9:30 PM
 */                

package siena.xml.tests;

import siena.xml.xpath.Predicate;
import siena.xml.xpath.BinaryNode;
import junit.framework.*;

/**
 *
 * @author unknown
 */                                
public class CompoundPredicateTest extends TestCase {
    
    public CompoundPredicateTest(java.lang.String testName) {
        super(testName);
    }        
    
    public static void main(java.lang.String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    public static Test suite() {
        TestSuite suite = new TestSuite(CompoundPredicateTest.class);
        
        return suite;
    }
    
    /** Test of getTree method, of class siena.xml.xpath.CompoundPredicate. */
    public void testGetTree() {
        siena.xml.xpath.CompoundPredicate predicate = null;
        System.out.println(" - Test: CompoundPredicate - getTree method");

        predicate = new siena.xml.xpath.CompoundPredicate("[substring(t,\"t\") and substring(2,\"2\")]");        
        BinaryNode root = predicate.getTree();
        assertEquals("Root data was not set correctly.", "AND", root.getData());
        assertNotNull("Left child of predicate was null when it should have been another node.", root.getLeftChild());
        assertNotNull("Right child of predicate was null when it should have been another node.", root.getRightChild());       
        assertTrue("Left child is not a function predicate.", root.getLeftChild().getData() instanceof siena.xml.xpath.FunctionPredicate);
        assertTrue("Right child is not a function predicate.", root.getRightChild().getData() instanceof siena.xml.xpath.FunctionPredicate);
        predicate = new siena.xml.xpath.CompoundPredicate("[x < 1 or ((y(y) and z<=2) or c!=4)]");
        root = predicate.getTree();
        assertNotNull("Root left child of predicate was null when it should have been another node.", root.getLeftChild());
        assertNotNull("Root right child of predicate was null when it should have been another node.", root.getRightChild());       
        assertNotNull("Root right, left child of predicate was null when it should have been another node.", root.getRightChild().getLeftChild());
        assertNotNull("Root right right child of predicate was null when it should have been another node.", root.getRightChild().getRightChild());       
        assertNotNull("Root right, left, left child of predicate was null when it should have been another node.", root.getRightChild().getLeftChild().getLeftChild());
        assertNotNull("Root right, left, right child of predicate was null when it should have been another node.", root.getRightChild().getLeftChild().getLeftChild());               
    }
}
