//
//  This file is part of SienaXML, an XML interface to the 
//  Siena wide-area event notification system.
//  See http://www.cs.colorado.edu/serl/siena/
//
//  Author: Chris Corliss <corliss@falcon.stortek.com>
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 2001-2002 University of Colorado
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
//
// $Id: PositionPredicateTest.java,v 1.1.1.1 2002/06/07 22:42:37 jgiacomo Exp $
//

/*
 * PositionPredicateTest.java
 * JUnit based test
 *
 * Created on December 2, 2001, 9:30 PM
 */                

package siena.xml.tests;

import siena.xml.xpath.PositionPredicate;
import junit.framework.*;

/**
 *
 * @author Chris Corliss
 */                                
public class PositionPredicateTest extends TestCase {
    
    public PositionPredicateTest(java.lang.String testName) {
        super(testName);
    }        
    
    public static void main(java.lang.String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    public static Test suite() {
        TestSuite suite = new TestSuite(PositionPredicateTest.class);
        
        return suite;
    }
    
    /** Test of getPosition method, of class siena.xml.xpath.PositionPredicate. */
    public void testGetPosition() {
        PositionPredicate predicate = null;
        
        System.out.println(" - Test: PositionPredicate - getPosition method");
        
        predicate = new PositionPredicate(0);
        assertEquals("The wrong position was set for the predicate.", 0, predicate.getPosition());
        predicate = new PositionPredicate("last()");
        assertEquals("The wrong position was set for the last() function", -1, predicate.getPosition());
        predicate = new PositionPredicate("position() = 2");
        assertEquals("The wrong position was set for the position function", 2, predicate.getPosition());
    }    
}
