//
//  This file is part of SienaXML, an XML interface to the 
//  Siena wide-area event notification system.
//  See http://www.cs.colorado.edu/serl/siena/
//
//  Author: Chris Corliss <corliss@falcon.stortek.com>
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 2001-2002 University of Colorado
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
//
// $Id: PredicateParser.java,v 1.1.1.1 2002/06/07 22:42:37 jgiacomo Exp $
//
// $ANTLR 2.7.1: "predicate.g" -> "PredicateParser.java"$
package siena.xml.xpath;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

import java.io.*;
import java.util.Vector;

/** Generated by ANTLR
 */
public class PredicateParser extends antlr.LLkParser
       implements PredicateParserTokenTypes
 {

protected PredicateParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public PredicateParser(TokenBuffer tokenBuf) {
  this(tokenBuf,6);
}

protected PredicateParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public PredicateParser(TokenStream lexer) {
  this(lexer,6);
}

public PredicateParser(ParserSharedInputState state) {
  super(state,6);
  tokenNames = _tokenNames;
}

	public final BinaryNode  predicate() throws RecognitionException, TokenStreamException {
		BinaryNode node;
		
		node = null;
		
		try {      // for error handling
			match(LEFTBRACE);
			node=predicateExpr();
			match(RIGHTBRACE);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_0);
		}
		return node;
	}
	
	public final BinaryNode  predicateExpr() throws RecognitionException, TokenStreamException {
		BinaryNode node;
		
		node = null;
		
		try {      // for error handling
			node=expr();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_1);
		}
		return node;
	}
	
	public final BinaryNode  expr() throws RecognitionException, TokenStreamException {
		BinaryNode node;
		
		node = null;
		
		try {      // for error handling
			node=orExpr();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_2);
		}
		return node;
	}
	
	public final BinaryNode  orExpr() throws RecognitionException, TokenStreamException {
		BinaryNode node;
		
		node = null; BinaryNode node2 = null; BinaryNode node3 = null;
		
		try {      // for error handling
			node2=andExpr();
			{
			switch ( LA(1)) {
			case OR:
			{
				match(OR);
				node3=orExpr();
				break;
			}
			case RIGHTBRACE:
			case COMA:
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if (node3 != null) {
			node = new BinaryNode();
			node.setData("OR");
			node.setLeftChild(node2);
			node.setRightChild(node3);
			} else {
			node = node2;
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_2);
		}
		return node;
	}
	
	public final BinaryNode  andExpr() throws RecognitionException, TokenStreamException {
		BinaryNode node = null;
		
		BinaryNode node2 = null;
		
		try {      // for error handling
			node=equalityExpr();
			{
			switch ( LA(1)) {
			case AND:
			{
				match(AND);
				node2=andExpr();
				break;
			}
			case OR:
			case RIGHTBRACE:
			case COMA:
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if (node2 != null) {
			BinaryNode rootNode = new BinaryNode();
			rootNode.setLeftChild(node);
			rootNode.setRightChild(node2);
			rootNode.setData("AND");
			node = rootNode;
			} 
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_3);
		}
		return node;
	}
	
	public final BinaryNode  equalityExpr() throws RecognitionException, TokenStreamException {
		BinaryNode expr=null;
		
		Token  eqType = null;
		BinaryNode equalNode = null;String temp = null;
		
		try {      // for error handling
			expr=relationalExpr();
			{
			switch ( LA(1)) {
			case NOT:
			case EQUAL:
			{
				{
				switch ( LA(1)) {
				case EQUAL:
				{
					eqType = LT(1);
					match(EQUAL);
					break;
				}
				case NOT:
				{
					match(NOT);
					match(EQUAL);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				equalNode=equalityExpr();
				break;
			}
			case AND:
			case OR:
			case RIGHTBRACE:
			case COMA:
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if (equalNode != null) {
			StringBuffer buffer = new StringBuffer();
			buffer.append(expr.getData());
			if (eqType != null) {
			buffer.append("= ");
			} else {
			buffer.append("!= ");
			}
			buffer.append(equalNode.getData());
			expr.setData(buffer.toString());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_4);
		}
		return expr;
	}
	
	public final BinaryNode  relationalExpr() throws RecognitionException, TokenStreamException {
		BinaryNode relexpr = null;
		
		Token  lessType = null;
		Token  equalType = null;
		Token  equalType2 = null;
		BinaryNode addNode = null;
		
		try {      // for error handling
			addNode=additiveExpr();
			{
			switch ( LA(1)) {
			case LESS:
			case GREATER:
			{
				{
				if ((LA(1)==LESS) && (_tokenSet_5.member(LA(2)))) {
					lessType = LT(1);
					match(LESS);
				}
				else if ((LA(1)==GREATER) && (_tokenSet_5.member(LA(2)))) {
					match(GREATER);
				}
				else if ((LA(1)==LESS) && (LA(2)==EQUAL)) {
					match(LESS);
					equalType = LT(1);
					match(EQUAL);
				}
				else if ((LA(1)==GREATER) && (LA(2)==EQUAL)) {
					match(GREATER);
					equalType2 = LT(1);
					match(EQUAL);
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				
				}
				relexpr=relationalExpr();
				break;
			}
			case AND:
			case OR:
			case NOT:
			case RIGHTBRACE:
			case COMA:
			case RPAREN:
			case EQUAL:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			
			if (relexpr != null) {
			StringBuffer buffer = new StringBuffer();      
			buffer.append(addNode.getData());
			buffer.append(" ");
			if (lessType != null) {
			buffer.append("<");
			} else {
			buffer.append(">");
			}
			if (equalType != null || equalType2 != null) {
			buffer.append("=");
			}
			buffer.append(" ");
			buffer.append(relexpr.getData());
			relexpr.setData(buffer.toString());
			} else {
			relexpr = addNode;
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_6);
		}
		return relexpr;
	}
	
	public final BinaryNode  additiveExpr() throws RecognitionException, TokenStreamException {
		BinaryNode node = null;
		
		Token  plusType = null;
		BinaryNode addNode = null;
		
		try {      // for error handling
			node=multiplicativeExpr();
			{
			switch ( LA(1)) {
			case PLUS:
			case MINUS:
			{
				{
				switch ( LA(1)) {
				case PLUS:
				{
					plusType = LT(1);
					match(PLUS);
					break;
				}
				case MINUS:
				{
					match(MINUS);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				addNode=additiveExpr();
				break;
			}
			case AND:
			case OR:
			case NOT:
			case RIGHTBRACE:
			case COMA:
			case RPAREN:
			case LESS:
			case GREATER:
			case EQUAL:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			
			if (addNode != null) {
			StringBuffer buffer = new StringBuffer();
			buffer.append(node.getData());
			buffer.append(" ");
			if (plusType != null) {
			buffer.append("+ ");
			} else {
			buffer.append("- ");
			}
			buffer.append(addNode.getData());
			node.setData(buffer.toString());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_7);
		}
		return node;
	}
	
	public final BinaryNode  multiplicativeExpr() throws RecognitionException, TokenStreamException {
		BinaryNode node = null;
		
		Token  star = null;
		Token  div = null;
		BinaryNode multNode = null;
		
		try {      // for error handling
			node=unaryExpr();
			{
			switch ( LA(1)) {
			case DIV:
			case MOD:
			case STAR:
			{
				{
				switch ( LA(1)) {
				case STAR:
				{
					star = LT(1);
					match(STAR);
					break;
				}
				case DIV:
				{
					div = LT(1);
					match(DIV);
					break;
				}
				case MOD:
				{
					match(MOD);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				multNode=multiplicativeExpr();
				break;
			}
			case AND:
			case OR:
			case NOT:
			case PLUS:
			case MINUS:
			case RIGHTBRACE:
			case COMA:
			case RPAREN:
			case LESS:
			case GREATER:
			case EQUAL:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			
			if (multNode != null) {
			StringBuffer buffer = new StringBuffer();
			buffer.append(node.getData());
			buffer.append(" ");
			if (star != null) {
			buffer.append("* ");
			} else if (div != null) {
			buffer.append("div ");
			} else {
			buffer.append("mod ");
			}
			buffer.append(node.getData());
			node.setData(buffer.toString());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_8);
		}
		return node;
	}
	
	public final BinaryNode  unaryExpr() throws RecognitionException, TokenStreamException {
		BinaryNode node = null;
		
		
		try {      // for error handling
			switch ( LA(1)) {
			case LPAREN:
			case DOLLARSIGN:
			case CHAR_LITERAL:
			case STRING_LITERAL:
			case INT:
			case ID:
			{
				node=primaryExpr();
				break;
			}
			case MINUS:
			{
				match(MINUS);
				node=unaryExpr();
				node.setData("- "+(String)node.getData());
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_9);
		}
		return node;
	}
	
	public final BinaryNode  primaryExpr() throws RecognitionException, TokenStreamException {
		BinaryNode node = null;
		
		Token  id = null;
		Token  integer = null;
		Token  string = null;
		Token  character = null;
		String temp = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case DOLLARSIGN:
			{
				temp=variableReference();
				node = new BinaryNode(); node.setData(temp);
				break;
			}
			case LPAREN:
			{
				match(LPAREN);
				node=expr();
				match(RPAREN);
				break;
			}
			case INT:
			{
				integer = LT(1);
				match(INT);
				node = new BinaryNode(); node.setData(integer.getText());
				break;
			}
			case STRING_LITERAL:
			{
				string = LT(1);
				match(STRING_LITERAL);
				node = new BinaryNode(); node.setData(string.getText());
				break;
			}
			case CHAR_LITERAL:
			{
				character = LT(1);
				match(CHAR_LITERAL);
				node = new BinaryNode(); node.setData(character.getText());
				break;
			}
			default:
				if ((LA(1)==ID) && (_tokenSet_9.member(LA(2)))) {
					id = LT(1);
					match(ID);
					node = new BinaryNode(); node.setData(id.getText());
				}
				else if ((LA(1)==ID) && (LA(2)==LPAREN||LA(2)==COLON)) {
					node=functionCall();
				}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_9);
		}
		return node;
	}
	
	public final String  variableReference() throws RecognitionException, TokenStreamException {
		String name = null;
		
		
		try {      // for error handling
			match(DOLLARSIGN);
			name=qname();
			name = "$"+name;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_9);
		}
		return name;
	}
	
	public final BinaryNode  functionCall() throws RecognitionException, TokenStreamException {
		BinaryNode node = new BinaryNode();
		
		String funcName = null; BinaryNode tempNode; StringBuffer buffer = new StringBuffer();
		
		try {      // for error handling
			funcName=functionName();
			match(LPAREN);
			
			buffer.append(funcName);
			buffer.append("(");
			
			{
			switch ( LA(1)) {
			case MINUS:
			case LPAREN:
			case DOLLARSIGN:
			case CHAR_LITERAL:
			case STRING_LITERAL:
			case INT:
			case ID:
			{
				tempNode=argument();
				buffer.append(tempNode.getData());
				{
				_loop28:
				do {
					if ((LA(1)==COMA)) {
						match(COMA);
						tempNode=argument();
						buffer.append(","); buffer.append(tempNode.getData());
					}
					else {
						break _loop28;
					}
					
				} while (true);
				}
				break;
			}
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(RPAREN);
			
			buffer.append(")");
			node.setData(buffer.toString());
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_9);
		}
		return node;
	}
	
	public final String  qname() throws RecognitionException, TokenStreamException {
		String name = null;
		
		Token  id1 = null;
		Token  id2 = null;
		
		try {      // for error handling
			{
			if ((LA(1)==ID) && (LA(2)==COLON)) {
				id1 = LT(1);
				match(ID);
				match(COLON);
			}
			else if ((LA(1)==ID) && (_tokenSet_10.member(LA(2)))) {
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
			}
			id2 = LT(1);
			match(ID);
			
			if (id1 != null) {
			name = id1.getText()+":"+id2.getText();
			} else {
			name = id2.getText();
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_10);
		}
		return name;
	}
	
	public final String  functionName() throws RecognitionException, TokenStreamException {
		String name = null;
		
		
		try {      // for error handling
			name=qname();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_11);
		}
		return name;
	}
	
	public final BinaryNode  argument() throws RecognitionException, TokenStreamException {
		BinaryNode node = null;
		
		
		try {      // for error handling
			node=expr();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_12);
		}
		return node;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"div\"",
		"\"mod\"",
		"\"and\"",
		"\"or\"",
		"WS",
		"NOT",
		"PLUS",
		"MINUS",
		"LEFTBRACE",
		"RIGHTBRACE",
		"COMA",
		"STAR",
		"LPAREN",
		"RPAREN",
		"LESS",
		"GREATER",
		"EQUAL",
		"BACKSLASH",
		"DOLLARSIGN",
		"CHAR_LITERAL",
		"STRING_LITERAL",
		"ESC",
		"DIGIT",
		"DOT",
		"INT",
		"an identifier",
		"COLON"
	};
	
	private static final long _tokenSet_0_data_[] = { 2L, 0L };
	public static final BitSet _tokenSet_0 = new BitSet(_tokenSet_0_data_);
	private static final long _tokenSet_1_data_[] = { 8192L, 0L };
	public static final BitSet _tokenSet_1 = new BitSet(_tokenSet_1_data_);
	private static final long _tokenSet_2_data_[] = { 155648L, 0L };
	public static final BitSet _tokenSet_2 = new BitSet(_tokenSet_2_data_);
	private static final long _tokenSet_3_data_[] = { 155776L, 0L };
	public static final BitSet _tokenSet_3 = new BitSet(_tokenSet_3_data_);
	private static final long _tokenSet_4_data_[] = { 155840L, 0L };
	public static final BitSet _tokenSet_4 = new BitSet(_tokenSet_4_data_);
	private static final long _tokenSet_5_data_[] = { 834734080L, 0L };
	public static final BitSet _tokenSet_5 = new BitSet(_tokenSet_5_data_);
	private static final long _tokenSet_6_data_[] = { 1204928L, 0L };
	public static final BitSet _tokenSet_6 = new BitSet(_tokenSet_6_data_);
	private static final long _tokenSet_7_data_[] = { 1991360L, 0L };
	public static final BitSet _tokenSet_7 = new BitSet(_tokenSet_7_data_);
	private static final long _tokenSet_8_data_[] = { 1994432L, 0L };
	public static final BitSet _tokenSet_8 = new BitSet(_tokenSet_8_data_);
	private static final long _tokenSet_9_data_[] = { 2027248L, 0L };
	public static final BitSet _tokenSet_9 = new BitSet(_tokenSet_9_data_);
	private static final long _tokenSet_10_data_[] = { 2092784L, 0L };
	public static final BitSet _tokenSet_10 = new BitSet(_tokenSet_10_data_);
	private static final long _tokenSet_11_data_[] = { 65536L, 0L };
	public static final BitSet _tokenSet_11 = new BitSet(_tokenSet_11_data_);
	private static final long _tokenSet_12_data_[] = { 147456L, 0L };
	public static final BitSet _tokenSet_12 = new BitSet(_tokenSet_12_data_);
	
	}
